/* runkit boilerplate -- you will do something else in your code */
var GOT = require('got');
var data = (await GOT('https://cdn.rawgit.com/SheetJS/js-xlsx/65f1c7e5/demos/extendscript/sheetjs.xlsx?raw=true', {encoding:'binary'})).body;

/* require XLSX */
var XLSX = require('xlsx');

/* read workbook */
var wb = XLSX.read(data, {type:'binary'});

/* generate array of arrays */
var js = XLSX.utils.sheet_to_json(wb.Sheets[wb.SheetNames[0]], {raw:true, header:1});;

/* loop the rows */
js.forEach(function(row, idx) { console.log(idx, row); });

/* change "A1" to 123 */
js[0][0] = 123;
js;;

/* Generate worksheet based on the array of arrays */
var new_ws = XLSX.utils.aoa_to_sheet(js);
new_ws;;

/* attach the new worksheet to the workbook.
   assigning to the old name overwrites the old worksheet */
wb.Sheets[wb.SheetNames[0]] = new_ws;;

/* generate the data 
   - bookType refers to output file type
   - type refers to the output data type
*/
var output = XLSX.write(wb, {bookType:"xlsx", type:"buffer"});
;

var new_wb = XLSX.read(output, {type:'buffer'});
var rt_js = XLSX.utils.sheet_to_json(new_wb.Sheets[new_wb.SheetNames[0]], {raw:true, header:1});;